#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <time.h>
#include <fcntl.h>
#include <sys/shm.h>
#include <sys/file.h>
#include "config.h"

void critical_section(int i){  //Critical section where the cstest is opened and written into with the time string
          sleep( 1 ); 
          FILE* file = fopen("cstest", "a");
                        if(file){
                                time_t t;
                                struct tm *tm_info;

                                time(&t);
                                tm_info = localtime(&t);

                                char timeStr[9]; //HH:MM:SS
                                strftime(timeStr, sizeof(timeStr), "%H:%M:%S", tm_info);
                                fprintf(file, "%s Process %02d entered the critical section:\n", timeStr, i);
                                fclose(file);
                        } else {
                                perror("File failed to open");
                        }
}

void process(int i, int* turn, State* flag){ //Function to allow one process to access the critical section at the time

        int j;
        int n = 20;

        int k;
        for(k = 0; k < 5; k++){ //Loop to limit each process to five entries

        do {
                do {
                        flag[i] = want_in;
                        j = turn;
                          while (j != i){
                                j = (flag[j] != idle) ? turn : (j + 1) % n;
                        }
                        flag[i] = in_cs;

                       for (j = 0; j < n; j++){
                                if((j != i) && (flag[j] == in_cs))
                                        break;
                        }
                } while (j < n || (turn != i && flag[turn] != idle));

                        turn = i;

                        char logFile[20];
                        sprintf(logFile, "logfile.%02d", i); //Creating logfiles for each processes
                        FILE* log = fopen(logFile, "a"); //Opening log files

                        if(log){
                        time_t t;
                        struct tm *tm_info;

                        memset ( &t, '\0', sizeof ( t ));
                        time(&t);
                        tm_info = localtime(&t);

                        char timeStr[9]; //HH:MM:SS
                        strftime(timeStr, sizeof(timeStr), "%H:%M:%S", tm_info);
                        fprintf(log, "%s Process %02d entered the critical section\n", timeStr, i); //Outputs the time when entering the critical section

                        sleep(rand() % 3 + 1);

                        critical_section(i);

                        sleep(rand() % 3 + 1);

                        fprintf(log, "%s Process %02d exited the critical section\n", timeStr, i); //Outputs the time when exiting the critical section
                        fclose(log);
                        } else {
                                perror("File failed to open");
                        }


                        j = (turn + 1) % n;

                        while (flag[j] == idle)
                                j = (j +1) % n;

                        turn = j;

                        flag[i] = idle;

                        sleep(rand() % 3 + 1);

                } while(1);
        }
}


int main(int argc, char *argv[]) {
        int n;
        int pid_logical = atoi(argv[1]);  //Accessing the child processes from argv1

        srand(time(NULL) +getpid());  //Generating random seed

        key_t key = ftok("shmfile", 65);  //Creating key for shared memory
        int shm_id = shmget(key, sizeof(int) + (MAX_N * sizeof(State)), 0666); //Allocating shared memory
        if (shm_id < 0) {
                perror("Error allocating shared memory.");
                exit(1);
        }

        int* shared_memory = shmat(shm_id, NULL, 0);
        int* turn = (int*) shared_memory;
        State* flag = (State*)(shared_memory + sizeof(int));

        process(pid_logical, turn, flag); //Function to processes child processes

        shmdt(shared_memory); //Clearing shared memory

 return 0; 
}


